#ifndef LIB_BOUNDS_C
#define LIB_BOUNDS_C 1
#pragma once

// types

	#pragma pack(push, 1)
	
	typedef struct { union { Vec2_i8 pos;  struct { i8 x;  i8 y;  }; }; union { Vec2_i8 size;  struct { i8 w;  i8 h;  }; }; } Bounds2_i8;
	typedef struct { union { Vec2_i16 pos; struct { i16 x; i16 y; }; }; union { Vec2_i16 size; struct { i16 w; i16 h; }; }; } Bounds2_i16;
	typedef struct { union { Vec2_i32 pos; struct { i32 x; i32 y; }; }; union { Vec2_i32 size; struct { i32 w; i32 h; }; }; } Bounds2_i32;
	typedef struct { union { Vec2_i64 pos; struct { i64 x; i64 y; }; }; union { Vec2_i64 size; struct { i64 w; i64 h; }; }; } Bounds2_i64;
	
	typedef struct { union { Vec2_u8 pos;  struct { u8 x;  u8 y;  }; }; union { Vec2_u8 size;  struct { u8 w;  u8 h;  }; }; } Bounds2_u8;
	typedef struct { union { Vec2_u16 pos; struct { u16 x; u16 y; }; }; union { Vec2_u16 size; struct { u16 w; u16 h; }; }; } Bounds2_u16;
	typedef struct { union { Vec2_u32 pos; struct { u32 x; u32 y; }; }; union { Vec2_u32 size; struct { u32 w; u32 h; }; }; } Bounds2_u32;
	typedef struct { union { Vec2_u64 pos; struct { u64 x; u64 y; }; }; union { Vec2_u64 size; struct { u64 w; u64 h; }; }; } Bounds2_u64;
	
	typedef struct { union { Vec2_f32 pos; struct { f32 x; f32 y; }; }; union { Vec2_f32 size; struct { f32 w; f32 h; }; }; } Bounds2_f32;
	typedef struct { union { Vec2_f64 pos; struct { f64 x; f64 y; }; }; union { Vec2_f64 size; struct { f64 w; f64 h; }; }; } Bounds2_f64;
	
	#pragma pack(pop)

// define

	static inline Bounds2_i8  bounds2_i8  (i8 x,  i8 y,  i8 w,  i8 h)  { return (Bounds2_i8){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_i16 bounds2_i16 (i16 x, i16 y, i16 w, i16 h) { return (Bounds2_i16){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_i32 bounds2_i32 (i32 x, i32 y, i32 w, i32 h) { return (Bounds2_i32){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_i64 bounds2_i64 (i64 x, i64 y, i64 w, i64 h) { return (Bounds2_i64){.x=x, .y=y, .w=w, .h=h}; }
	
	static inline Bounds2_u8  bounds2_u8  (u8 x,  u8 y,  u8 w,  u8 h)  { return (Bounds2_u8){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_u16 bounds2_u16 (u16 x, u16 y, u16 w, u16 h) { return (Bounds2_u16){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_u32 bounds2_u32 (u32 x, u32 y, u32 w, u32 h) { return (Bounds2_u32){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_u64 bounds2_u64 (u64 x, u64 y, u64 w, u64 h) { return (Bounds2_u64){.x=x, .y=y, .w=w, .h=h}; }
	
	static inline Bounds2_f32 bounds2_f32 (f32 x, f32 y, f32 w, f32 h) { return (Bounds2_f32){.x=x, .y=y, .w=w, .h=h}; }
	static inline Bounds2_f64 bounds2_f64 (f64 x, f64 y, f64 w, f64 h) { return (Bounds2_f64){.x=x, .y=y, .w=w, .h=h}; }

// shorter names

	typedef Bounds2_i32 Bounds2i;
	typedef Bounds2_f32 Bounds2f;
	#define bounds2i bounds2_i32
	#define bounds2f bounds2_f32

// include guard
#endif